unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, Spin, LCLProc;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonAdd: TButton;
    ButtonClearCombo: TButton;
    ButtonSetIndex: TButton;
    ButtonClearLog: TButton;
    ButtonDelete: TButton;
    ButtonSetText: TButton;
    ButtonGetIndex: TButton;
    ButtonGetText: TButton;
    ComboBoxTest: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    ListBoxLog: TListBox;
    SpinEdit1: TSpinEdit;
    procedure ButtonAddClick(Sender: TObject);
    procedure ButtonClearComboClick(Sender: TObject);
    procedure ButtonSetIndexClick(Sender: TObject);
    procedure ButtonClearLogClick(Sender: TObject);
    procedure ButtonDeleteClick(Sender: TObject);
    procedure ButtonSetTextClick(Sender: TObject);
    procedure ButtonGetIndexClick(Sender: TObject);
    procedure ButtonGetTextClick(Sender: TObject);
    procedure ComboBoxTestChange(Sender: TObject);
    procedure ComboBoxTestSelect(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.ButtonAddClick(Sender: TObject);
begin
  ComboBoxTest.Items.Add(Chr(ComboBoxTest.Items.Count+65));
  SpinEdit1.MaxValue := ComboBoxTest.Items.Count-1;
end;

procedure TForm1.ButtonClearComboClick(Sender: TObject);
begin
  ComboBoxTest.Clear;
end;

procedure TForm1.ButtonSetIndexClick(Sender: TObject);
begin
  if ComboBoxTest.Items.Count > 0 then
    ComboBoxTest.ItemIndex:=SpinEdit1.Value;
end;

procedure TForm1.ButtonClearLogClick(Sender: TObject);
begin
  ListBoxLog.Clear;
end;

procedure TForm1.ButtonDeleteClick(Sender: TObject);
begin
  with ComboBoxTest do
    if ItemIndex <> -1 then
     Items.Delete(ItemIndex);
end;

procedure TForm1.ButtonSetTextClick(Sender: TObject);
begin
  ComboBoxTest.Text:='vcvcvcvcv';
end;

procedure TForm1.ButtonGetIndexClick(Sender: TObject);
begin
  Label1.Caption:=IntToStr(ComboBoxTest.ItemIndex);
end;

procedure TForm1.ButtonGetTextClick(Sender: TObject);
begin
  Label2.Caption := ComboBoxTest.Text;
end;

procedure TForm1.ComboBoxTestChange(Sender: TObject);
begin
  //WriteLn('* Change *');
  //DumpStack;
  //WriteLn('-----');
  ListBoxLog.Items.Add('ComboBoxChange called - Index: '+IntToStr(ComboBoxTest.ItemIndex));
end;

procedure TForm1.ComboBoxTestSelect(Sender: TObject);

begin
  //WriteLn('* Select *');
  //DumpStack;
  //WriteLn('-----');
  ListBoxLog.Items.Add('ComboBoxSelect called - Index: '+IntToStr(ComboBoxTest.ItemIndex));
end;

initialization
  {$I unit1.lrs}

end.

